------------------------------------------------------------------------------------------
-- LoadAndSave file
-- Written by Homeopatix
-- 26 january 2021
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-- create or load the settings
------------------------------------------------------------------------------------------
function LoadSettings()
	local _settings = PatchDataLoad(Turbine.DataScope.Character, "WhereToPlay_Settings", settings);
    if (_settings ~= nil) then 
		settings = _settings; 
	end
------------------------------------------------------------------------------------------
--- adding new vars in the settings file ---
------------------------------------------------------------------------------------------
    if ( not settings.isFarmWindowVisible) then
		settings = {
            windowPosition = { 
                xPos = 500, 
                yPos = 500 
            },
            IconPosition = { 
                xPosIcon = 500, 
                yPosIcon = 500 
            },
            isMinimizeEnabled = { 
                isMinimizeEnabled = false 
            },
            isWindowVisible = { 
                isWindowVisible = true 
            },
            isOptionsWindowVisible = { 
                isOptionsWindowVisible = false 
            },
            isMapWindowVisible = { 
                value = false 
            },
            isFarmWindowVisible = { 
                value = false 
            },
            verbose = { 
                value = false 
            },
            escEnable = { 
                escEnable = true 
            }
        };
	end
end
------------------------------------------------------------------------------------------
-- create the save settings
------------------------------------------------------------------------------------------
function SaveSettings()
	settings["windowPosition"]["xPos"] = tostring(WhereToPlay:GetLeft());
    settings["windowPosition"]["yPos"] = tostring(WhereToPlay:GetTop());
    settings["IconPosition"]["xPosIcon"] = tostring(MainMinimizedIcon:GetLeft());
   	settings["IconPosition"]["yPosIcon"] = tostring(MainMinimizedIcon:GetTop());
	settings["isMinimizeEnabled"]["isMinimizeEnabled"] = settings["isMinimizeEnabled"]["isMinimizeEnabled"];
	settings["isWindowVisible"]["isWindowVisible"] = settings["isWindowVisible"]["isWindowVisible"];
    settings["isOptionsWindowVisible"]["isOptionsWindowVisible"] = settings["isOptionsWindowVisible"]["isOptionsWindowVisible"];
	settings["isMapWindowVisible"]["value"] = settings["isMapWindowVisible"]["value"];
	settings["isFarmWindowVisible"]["value"] = settings["isFarmWindowVisible"]["value"];

	PatchDataSave( Turbine.DataScope.Character, "WhereToPlay_Settings", settings);
end